
from pathlib import Path

import datetime
import logging

import pandas as pd

import pacs

def get_pacs(series, outdir, max_patients=10):
    app, window = pacs.login()
    num_patients = 0
    for index, row in series.iterrows():
        chartno = str(row.CHARTNO).zfill(7)
        # chartno = str(int(row.CHARTNO)).zfill(7)
        # print(chartno)
        # continue
        # exit()

        # if isinstance(row, float):
        #     row = int(row)
        # chartno = str(int(row)).zfill(7)
        
        complete_file = Path(f'{outdir}\\{chartno}.complete')
        if complete_file.is_file():
            logging.warning('skip '+chartno)
            continue

        logging.warning('saving '+chartno)
        pacs.save_patient(chartno, f'{outdir}\\{chartno}', query="CT,MR")
        
        complete_file.touch()
        num_patients += 1
        if num_patients >= max_patients:
            break

    logging.warning('%d patients completed' % num_patients)
    return num_patients


def main():
    FORMAT = '%(asctime)s %(message)s'
    logging.basicConfig(filename=__file__.replace('.py','.%s.log'%str(datetime.datetime.now()).replace(':','')), 
                        format=FORMAT)



    # df = pd.read_excel('pituitary-srs.xlsx', sheet_name='NFA Data (n=178)', header=1)
    df = pd.read_csv('C1053_01_CHARTNO_1.txt', sep="\t", header=0)
    # print(df)
    # exit()
    series=df.reindex(index=df.index[::-1])
    # print(series)
    # exit()

    outdir = r'T:\icu_ventricle'

    get_pacs(series, outdir)
    return 0


if __name__ == '__main__':
    main()
